//---------------------------------------------------------------------------
#include <vcl.h>
#include <shellapi.h> //SHGetFileInfo API
#include <dshow.h> //DirectX8 SDK
#include <stdio.h>
#pragma hdrstop

#include "ifmmedia.h"
#include "ifmmvar.h"
#include "Unit1.h"

//#define USE_SAMPLEGRABBER

extern ifmmVar ifmmvar;
//---------------------------------------------------------------------------
//t@C̎ނ𔻒
//data     : t@C擪̃f[^
//filename : t@C
//return   : t@C^CvԂ
unsigned int __fastcall GetFileType(const char *data, const char *filename)
{
    unsigned int filetype = FT_UNKNOWN;
    bool playable[FT_COUNT];
    UNKNOWN_FILE *mm_h = (UNKNOWN_FILE *)data;
    ifmmvar.Getplayable(playable);

    if (ifmmvar.GetOption(IFMMOPT_DebugMode)) {
        //SusieɁuΉĂvƕԎ
        //̂ŁAĐł邩Ƃ\
        return FT_DEBUG;
    }

    if (
        /* WAVE */
          playable[WAVEPLAY] &&
          (   mm_h->uk1 == RIFF_TYPE_ID
           && mm_h->uk3 == WAVE_TYPE_ID )
       )
    {
            filetype = FT_WAVE;
    } else if (
        /* AIFF */
          playable[AIFFPLAY] &&
        (   mm_h->uk1 == FORM_TYPE_ID
         && mm_h->uk3 == AIFF_TYPE_ID
         && mm_h->uk4 == COMM_TYPE_ID )
              )
    {
            filetype = FT_AIFF;
    } else if (
        /* MIDI */
          playable[MIDIPLAY] &&
       (  (   mm_h->uk1 == MTHD_TYPE_ID
           && mm_h->uk2 == MIDI_H_SIZE
           && *((int *)(data +0x0e)) == MTRK_TYPE_ID )
            ||
          (   mm_h->uk1 == RIFF_TYPE_ID
           && (mm_h->uk3 == RMID_TYPE_ID /*|| mm_h->uk3 == MIDS_TYPE_ID*/) )
       )
              )
    {
            filetype = FT_MIDI;
    } else if (
        /* AVI */
          playable[AVIPLAY] &&
        (   mm_h->uk1 == RIFF_TYPE_ID
         && mm_h->uk3 == AVI_TYPE_ID )
              )
    {
            filetype = FT_AVI;
    } else if (
        /* MOV */
          playable[MOVPLAY] &&
        (   mm_h->uk2 == MDAT_TYPE_ID
         || mm_h->uk2 == MOOV_TYPE_ID
         || mm_h->uk4 == MDAT_TYPE_ID
         || mm_h->uk4 == MOOV_TYPE_ID )
              )
    {
            filetype = FT_MOV;
    } else if (
        /* MPEG */
          playable[MPEGPLAY] &&
          (
              (mm_h->uk1 == MPEG_A_TYPE_ID) ||
              (mm_h->uk1 == MPEG_B_TYPE_ID) ||
            (   mm_h->uk1 == RIFF_TYPE_ID
             && mm_h->uk3 == CDXA_TYPE_ID
             && mm_h->uk4 == FMT_TYPE_ID
             //&& *((int *)(data +0x18)) == XA_TYPE_ID
             )
          )
        )
    {
            filetype = FT_MPEG;
    } else if (
        /* MPEG Audio */
          playable[MPAPLAY] &&
       ( (mm_h->uk1 & 0x00ffffff) == ID3TAG_ID
         ||
        (
         (mm_h->uk1 & 0xf0ff) == MPA_TYPE_ID //wb_
         && (*(data +1) & 0x06) != 0x00      //C
         && (*(data +2) & 0xf0) != 0xf0      //rbg[g
         && (*(data +2) & 0x0c) != 0x0c      //TvO[g
         //&& (*(data +3) & 0x03) != 0x02      //Gt@VX
        )
         ||
        ( mm_h->uk1 == RIFF_TYPE_ID
          && mm_h->uk3 == RMP3_TYPE_ID
        )
       )
              )
    {
            filetype = FT_MPA;
    } else if (
        /* AU */
          playable[AUPLAY] &&
         (mm_h->uk1 == SND_TYPE_ID)
              )
    {
            filetype = FT_AU;
    } else if (
        /* OGG */
          playable[OGGPLAY] &&
         (mm_h->uk1 == OGG_TYPE_ID)
              )
    {
            filetype = FT_OGG;
    } else if (
        /* RealMedia */
          playable[RMPLAY] &&
         (mm_h->uk1 == RM_TYPE_ID)
              )
    {
            filetype = FT_RM;
    } else {
        /* WMA, WMV, ASF */
        // ͊gqŔf
        AnsiString ext = ExtractFileExt((AnsiString)filename).LowerCase();
        if (playable[WMAPLAY] && ext == ".wma") {
            filetype = FT_WMA;
        } else if (playable[WMVPLAY] && ext == ".wmv") {
            filetype = FT_WMV;
        } else if (playable[ASFPLAY] && ext == ".asf") {
            filetype = FT_ASF;
        }
    }

    return filetype;
}
//---------------------------------------------------------------------------
//t@C^CṽACRnh𓾂
//filetype : t@C^Cv
//return   : ACRnhԂ
HICON __fastcall GetIconHandle(const unsigned int filetype, unsigned int flag)
{
    SHFILEINFO FileInfo;
    char *ext_tbl[] = { "*.wav", /* 0 */ //t@C^CvƓ悤Ȋ
                        "*.wav", /* 1 */
                        "*.aif",
                        "*.mid",
                        "*.avi",
                        "*.mov", /* 5 */
                        "*.mpg",
                        "*.mpa",
                        "*.au",
                        "*.wma",
                        "*.wmv", /* 10 */
                        "*.asf",
                        "*.ogg",
                        "*.rm",  /* 13 */
                        };
    unsigned int index = (filetype & 0xff);

    ::SHGetFileInfo(ext_tbl[index], NULL, &FileInfo, sizeof(SHFILEINFO),
                SHGFI_USEFILEATTRIBUTES | SHGFI_ICON | flag);
    //ACR̃nhFileInfo.hIconɓĂ
    return FileInfo.hIcon;
}
//---------------------------------------------------------------------------
//ACRnhDIB쐬
//pHBInfo  : SusieɕԂBITMAPINFO߂nh̃|C^
//pHBm     : SusieɕԂBITMAPf[^߂nh̃|C^
//filetype : t@C^Cv
bool __fastcall GetFileIcon(HANDLE *pHBInfo, HANDLE *pHBm, const unsigned int filetype)
{
    //܂肭ǂC...
    HICON hIcon;
    bool ret;
    Graphics::TBitmap *bmp = new (Graphics::TBitmap);
    TMemoryStream *MS = new TMemoryStream();
    hIcon = GetIconHandle(filetype, SHGFI_LARGEICON);
    bmp->Height = 32; //32ł̂H...
    bmp->Width  = 32;
    bmp->PixelFormat = pf24bit; //24rbgɂȂH
    ret = ::DrawIconEx(bmp->Canvas->Handle, 0, 0, hIcon, 0, 0, 0, NULL, DI_NORMAL);
    bmp->SaveToStream(MS);

if (ret) {
    unsigned char *buffer = (unsigned char *)MS->Memory;

    BITMAPFILEHEADER *pbm_fh;
    BITMAPINFOHEADER *pbm_info;
    pbm_fh = (BITMAPFILEHEADER *)buffer;
    pbm_info = (BITMAPINFOHEADER *)(buffer +sizeof(BITMAPFILEHEADER));
    int img_size = pbm_info->biWidth * 3;
    img_size = (img_size +3) & ~3; //4byteEɍ킹
    img_size *= pbm_info->biHeight;
    *pHBInfo = LocalAlloc(LMEM_MOVEABLE, sizeof(BITMAPINFOHEADER));
    *pHBm    = LocalAlloc(LMEM_MOVEABLE, img_size);

    BITMAPINFOHEADER *pInfo;
    pInfo = (BITMAPINFOHEADER *)LocalLock(*pHBInfo);
    pInfo->biSize          = sizeof(BITMAPINFOHEADER);
    pInfo->biWidth         = pbm_info->biWidth;
    pInfo->biHeight        = pbm_info->biHeight;
    pInfo->biPlanes        = 1;
    pInfo->biBitCount      = 24;
    pInfo->biCompression   = 0;
    pInfo->biSizeImage     = img_size;
    pInfo->biXPelsPerMeter = 0;
    pInfo->biYPelsPerMeter = 0;
    pInfo->biClrUsed       = 0;
    pInfo->biClrImportant  = 0;

    unsigned char *Bm = (unsigned char *)LocalLock(*pHBm);
    unsigned char *tmp = buffer +pbm_fh->bfOffBits;
    memcpy(Bm, tmp, img_size);

    LocalUnlock(*pHBm);
    LocalUnlock(*pHBInfo);
}

    DestroyIcon(hIcon);
    delete MS;
    delete bmp;

    return ret;
}
//---------------------------------------------------------------------------
//e|t@C쐬
//tempfname : 쐬e|t@CԂ
//buf       : f[^ւ̃|C^
//len       : f[^TCY
//return    : 쐬ɐtrueAsfalseԂ
bool __fastcall PutTempFile(char *tempfname, const char *buf, const long len)
{
    HANDLE htempf;
    DWORD ReadBytes;

    char temppath[MAX_PATH];
    //e|tH_̃pX擾
    if (GetTempPath(MAX_PATH, temppath) == 0) {
        //MessageBox(NULL, "e|tH_̎擾ɎsB", "ifmm.spi", MB_OK);
        return false;
    }
    if (GetTempFileName(temppath, "ifm", 0, tempfname) == 0) {
        //MessageBox(NULL, "e|t@C̍쐬ɎsB", "ifmm.spi", MB_OK);
        return false;
    }
    htempf = CreateFile(tempfname, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    if (htempf == INVALID_HANDLE_VALUE) {
        //MessageBox(NULL, "e|t@C̍쐬ɎsB", "ifmm.spi", MB_OK);
        return false;
    }
    if (!WriteFile(htempf, buf, len, &ReadBytes, NULL)) {
        //MessageBox(NULL, "e|t@C݂̏ɎsB", "ifmm.spi", MB_OK);
        CloseHandle(htempf);
        DeleteFile(tempfname);
        return false;
    }
    CloseHandle(htempf);

    return true;
}
//---------------------------------------------------------------------------
#ifndef USE_SAMPLEGRABBER
//24bitɕϊ
//dibimg  : DIBC[Wւ̃|C^
//imgsize : DIBC[Wobt@̃TCY
//pHBInfo : SusieɕԂBITMAPINFO߂nh̃|C^
//pHBm    : SusieɕԂBITMAPf[^߂nh̃|C^
//return  : trueAsfalseԂ
bool __fastcall to24bit(const char *dibimg, unsigned int imgsize, HANDLE *pHBInfo, HANDLE *pHBm)
{
    long infosize;
    unsigned char *pbmdata;
    BITMAPINFOHEADER *pbmih;
    BITMAPINFOHEADER *pbmpinfo = (BITMAPINFOHEADER *)dibimg;
    infosize = pbmpinfo->biSize;
    if (pbmpinfo->biBitCount != 16 && pbmpinfo->biBitCount != 32) {
        //pbg̕
        if (pbmpinfo->biBitCount != 24) {
            infosize += sizeof(RGBQUAD) * (1 << pbmpinfo->biBitCount) ;
        }
        if (pbmpinfo->biSizeImage == 0) {
            pbmpinfo->biSizeImage = imgsize - infosize;
        }
        *pHBInfo = LocalAlloc(LMEM_MOVEABLE, infosize);
        *pHBm = LocalAlloc(LMEM_MOVEABLE, pbmpinfo->biSizeImage);
        if (*pHBInfo == NULL || *pHBm == NULL) {
            if (*pHBInfo != NULL) LocalFree(*pHBInfo);
            if (*pHBm != NULL) LocalFree(*pHBm);
            *pHBInfo = NULL;
            *pHBm = NULL;
            return false;
        }
        pbmih = (BITMAPINFOHEADER *)LocalLock(*pHBInfo);
        pbmdata = (unsigned char *)LocalLock(*pHBm);
        memcpy(pbmih, dibimg, infosize);
        memcpy(pbmdata, dibimg +infosize, pbmpinfo->biSizeImage);
    } else {
        //}XNH
        if (pbmpinfo->biCompression == BI_BITFIELDS) {
            infosize += sizeof(DWORD) * 3;
        }
        int linesize24 = (pbmpinfo->biWidth * 3 +3) & ~3; //4byteE
        long dib24imgsize = linesize24 * abs(pbmpinfo->biHeight); //Height͕肦H
        pbmpinfo->biSizeImage = dib24imgsize;
        *pHBInfo = LocalAlloc(LMEM_MOVEABLE, sizeof(BITMAPINFOHEADER));
        *pHBm = LocalAlloc(LMEM_MOVEABLE, dib24imgsize);
        if (*pHBInfo == NULL || *pHBm == NULL) {
            if (*pHBInfo != NULL) LocalFree(*pHBInfo);
            if (*pHBm != NULL) LocalFree(*pHBm);
            *pHBInfo = NULL;
            *pHBm = NULL;
            return false;
        }
        pbmdata = (unsigned char *)LocalLock(*pHBm);

        //16bit, 32bit24bitɕϊ
        //SusieuSɂ́vΉĂȂ
        //BI_BITFIELDSɑΉĂȂ݂
        if (pbmpinfo->biBitCount == 16) {
            unsigned short r_mask;
            unsigned short g_mask;
            unsigned short b_mask;
            unsigned char *pbmp;
            unsigned short tshort;
            unsigned char *pimg_base = (unsigned char *)dibimg +infosize;
            unsigned short *pimg;
            //4byteE
            int linesize16 = (pbmpinfo->biWidth * 2 +3) & ~3;
            int r_shift = 0;
            int g_shift = 0;
            int b_shift = 0;
            int r_bit = 0;
            int g_bit = 0;
            int b_bit = 0;
            if (pbmpinfo->biCompression == BI_BITFIELDS) {
                unsigned int *mask = (unsigned int *)(dibimg +pbmpinfo->biSize);
                r_mask = *(mask +0);
                g_mask = *(mask +1);
                b_mask = *(mask +2);
                //Vtgrbg
                while (((r_mask >> r_shift) & 1) == 0) r_shift++;
                while (((g_mask >> g_shift) & 1) == 0) g_shift++;
                while (((b_mask >> b_shift) & 1) == 0) b_shift++;
                //rbg邩
                while (((r_mask >> (r_shift +r_bit)) & 1) == 1) r_bit++;
                while (((g_mask >> (g_shift +g_bit)) & 1) == 1) g_bit++;
                while (((b_mask >> (b_shift +b_bit)) & 1) == 1) b_bit++;
            } else {
                //ftHg555̂͂
                r_mask = 0x7c00;
                g_mask = 0x03e0;
                b_mask = 0x001f;
                r_shift = 10;
                g_shift = 5;
                b_shift = 0;
                r_bit = 5;
                g_bit = 5;
                b_bit = 5;
            }
            int height = abs(pbmpinfo->biHeight);
            for (int y=0; y < height; y++) {
                pbmp = (unsigned char *)pbmdata +linesize24 * y;
                pimg = (unsigned short *)(pimg_base +linesize16 * y);
                for (int x=0; x < pbmpinfo->biWidth; x++) {
                    unsigned char r,g,b;
                    tshort = *(pimg++);
                    b = ((tshort & b_mask) >> b_shift) << (8 -b_bit);
                    g = ((tshort & g_mask) >> g_shift) << (8 -g_bit);
                    r = ((tshort & r_mask) >> r_shift) << (8 -r_bit);
                    //PɃVtgł͐FςB
                    //VtgʂĂƗǂ݂B
                    b = b | (b >> b_bit);
                    g = g | (g >> g_bit);
                    r = r | (r >> r_bit);
                    *(pbmp++) = b;
                    *(pbmp++) = g;
                    *(pbmp++) = r;
                }
            }
        } else { //32bit
            unsigned int r_mask;
            unsigned int g_mask;
            unsigned int b_mask;
            unsigned char *pbmp;
            unsigned char *temp = (unsigned char *)dibimg +infosize;
            unsigned int *pimg = (unsigned int *)temp;
            int r_shift = 0;
            int g_shift = 0;
            int b_shift = 0;
            int r_bit = 0;
            int g_bit = 0;
            int b_bit = 0;
            if (pbmpinfo->biCompression == BI_BITFIELDS) {
                unsigned int *mask = (unsigned int *)(dibimg +pbmpinfo->biSize);
                r_mask = *(mask +0);
                g_mask = *(mask +1);
                b_mask = *(mask +2);
                while (((r_mask >> r_shift) & 1) == 0) r_shift++;
                while (((g_mask >> g_shift) & 1) == 0) g_shift++;
                while (((b_mask >> b_shift) & 1) == 0) b_shift++;
                while (((r_mask >> (r_shift +r_bit)) & 1) == 1) r_bit++;
                while (((g_mask >> (g_shift +g_bit)) & 1) == 1) g_bit++;
                while (((b_mask >> (b_shift +b_bit)) & 1) == 1) b_bit++;
            } else {
                r_mask = 0x00ff0000;
                g_mask = 0x0000ff00;
                b_mask = 0x000000ff;
                r_shift = 16;
                g_shift = 8;
                b_shift = 0;
                r_bit = 8;
                g_bit = 8;
                b_bit = 8;
            }
            int height = abs(pbmpinfo->biHeight);
            for (int y=0; y < height; y++) {
                pbmp = (unsigned char *)pbmdata +linesize24 * y;
                for (int x=0; x < pbmpinfo->biWidth; x++) {
                    *(pbmp++) = (unsigned char)(((*pimg & b_mask) >> b_shift) >> (b_bit -8));
                    *(pbmp++) = (unsigned char)(((*pimg & g_mask) >> g_shift) >> (g_bit -8));
                    *(pbmp++) = (unsigned char)(((*pimg & r_mask) >> r_shift) >> (r_bit -8));
                    pimg++;
                }
            }
        }
        pbmpinfo->biSize          = sizeof(BITMAPINFOHEADER);
        pbmpinfo->biBitCount      = 24;
        pbmpinfo->biCompression   = BI_RGB;
        pbmpinfo->biXPelsPerMeter = 0;
        pbmpinfo->biYPelsPerMeter = 0;
        pbmpinfo->biClrUsed       = 0;
        pbmpinfo->biClrImportant  = 0;
        pbmih = (BITMAPINFOHEADER *)LocalLock(*pHBInfo);
        memcpy(pbmih, dibimg, sizeof(BITMAPINFOHEADER));
    }

    LocalUnlock(*pHBm);
    LocalUnlock(*pHBInfo);
    return true;
}
#endif
//---------------------------------------------------------------------------
//摜܂͔摜`FbN(24bit)
//ȂtrueԂ
//dibimg  : DIBC[Wւ̃|C^
//imgsize : DIBC[Wobt@̃TCY
//pHBInfo : SusieɕԂBITMAPINFO߂nh̃|C^
//pHBm    : SusieɕԂBITMAPf[^߂nh̃|C^
bool __fastcall BWcheck(HANDLE *pHBInfo, HANDLE *pHBm)
{
    unsigned char *pbmdata;
    BITMAPINFOHEADER *pbmih;
    bool ret = true;

    pbmih = (BITMAPINFOHEADER *)LocalLock(*pHBInfo);
    pbmdata = (unsigned char *)LocalLock(*pHBm);

    unsigned int linesize = (pbmih->biWidth * 3 + 3) & ~3;
for (int y=0; y<abs(pbmih->biHeight); y++) {
    unsigned int *p = (unsigned int*)(pbmdata +linesize*y);
    unsigned int b=0; //
    unsigned int w=0; //

    //ȃ`FbNŗǂ̂H
    for (unsigned int x=0; x<linesize/4; x++) {
        b |= *p;
        w |= ~(*p);
        p++;
    }
    b = (b >> 24) | (b >> 16) | (b >> 8) | b;
    b = (b & 0xf8);
    w = (w >> 24) | (w >> 16) | (w >> 8) | w;
    w = (w & 0xf8);
    if (b != 0 && w != 0) {
        ret = false;
        break;
    }
}

    LocalUnlock(*pHBm);
    LocalUnlock(*pHBInfo);
    return ret;
}
//---------------------------------------------------------------------------
//̃t[DIBɕϊ
//filename : t@CpX
//pHBInfo  : SusieɕԂBITMAPINFO߂nh̃|C^
//pHBm     : SusieɕԂBITMAPf[^߂nh̃|C^
//return   : trueAsfalseԂ
#ifdef USE_SAMPLEGRABBER
#include <qedit.h> //ISampleGrabber
#pragma link "strmiids.lib" //ISampleGrabber
bool __fastcall GetMovieFrame(const char *filename, HANDLE *pHBInfo, HANDLE *pHBm)
{
    bool ret = true;
    HRESULT hr;
    WCHAR wFile[MAX_PATH];
    IGraphBuilder *pigb = NULL;
    IBaseFilter     *pF = NULL;
    ISampleGrabber  *pGrab = NULL;
    AM_MEDIA_TYPE   mt;
    IMediaControl   *pMediaControl = NULL;
    IMediaSeeking   *pSeek = NULL;
    IMediaEvent     *pEvent = NULL;

    double seektime[2] = {0.0, 0.0};
    ifmmvar.GetPreviewPos(seektime);


    CoInitialize(NULL);
    hr = CoCreateInstance(CLSID_FilterGraph,
                          NULL,
                          CLSCTX_INPROC_SERVER,
                          IID_IGraphBuilder,
                          (void**)&pigb);
    if (FAILED(hr)) {
        //MessageBox(NULL, "DirectShow̏ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto CREATE_ERR;
    }
    hr = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER,
                    IID_IBaseFilter, (LPVOID *)&pF);
    if (FAILED(hr)) {
        //MessageBox(NULL, "IBaseFilter̍쐬ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto CREATE_ERR;
    }
    hr = pF->QueryInterface(IID_ISampleGrabber, (void **)&pGrab);
    if (FAILED(hr)) {
        //MessageBox(NULL, "ISampleGrabber̎擾ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto NO_INTERFACE;
    }
    hr = pigb->QueryInterface(IID_IMediaControl, (void**)&pMediaControl);
    if (FAILED(hr)) {
        //MessageBox(NULL, "IMediaControl̎擾ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto NO_INTERFACE;
    }
	hr = pigb->QueryInterface(IID_IMediaSeeking, (void **)&pSeek);
    if (FAILED(hr)) {
        //MessageBox(NULL, "IMediaSeeking̎擾ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto NO_INTERFACE;
    }
	hr = pigb->QueryInterface(IID_IMediaEvent, (void **)&pEvent);
    if (FAILED(hr)) {
        //MessageBox(NULL, "IMediaEvent̎擾ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto NO_INTERFACE;
    }


    pigb->AddFilter(pF, L"Grabber");
    ZeroMemory(&mt, sizeof(AM_MEDIA_TYPE));
    mt.majortype = MEDIATYPE_Video;
    mt.subtype = MEDIASUBTYPE_RGB24;
    mt.formattype = FORMAT_VideoInfo;
    hr = pGrab->SetMediaType(&mt);

    MultiByteToWideChar(CP_ACP, 0, filename, -1, wFile, MAX_PATH);
    hr = pigb->RenderFile(wFile, NULL);
    if (FAILED(hr)) {
        //MessageBox(NULL, "RenderFile()ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto OPEN_ERR;
    }

    // Vbg [hݒ肷B
    pGrab->SetBufferSamples(TRUE);
    pGrab->SetOneShot(TRUE);

for (int i=0; i<2; i++) {
    // wbV[NB
    REFERENCE_TIME rtStart = seektime[i] * 10000000;
    REFERENCE_TIME rtStop = rtStart;
    hr = pSeek->SetPositions(&rtStart, AM_SEEKING_AbsolutePositioning,
                         &rtStop, AM_SEEKING_AbsolutePositioning);

    // OtsAI҂B
    long evCode;
    hr = pMediaControl->Run();
    hr = pEvent->WaitForCompletion(INFINITE, &evCode);


    AM_MEDIA_TYPE MediaType;
    pGrab->GetConnectedMediaType(&MediaType);

    // rfI wb_[ւ̃|C^lB
    VIDEOINFOHEADER *pVideoHeader = (VIDEOINFOHEADER*)MediaType.pbFormat;

    // rfI wb_[ɂ́Arbg}bv񂪊܂܂B
    *pHBInfo = LocalAlloc(LMEM_FIXED, sizeof(BITMAPINFOHEADER));
    if (*pHBInfo == NULL) {
        ret = false;
        //MessageBox(NULL, "s", "ifmm.spi", MB_OK);
        goto NO_MEMORY_BMH;
    }
    memcpy(*pHBInfo, &(pVideoHeader->bmiHeader), sizeof(BITMAPINFOHEADER));
    // C[WRs[B
    long BufferSize = 0;
    hr = pGrab->GetCurrentBuffer(&BufferSize, NULL);
    *pHBm = LocalAlloc(LMEM_FIXED, BufferSize);
    if (*pHBm == NULL) {
        ret = false;
        //MessageBox(NULL, "s", "ifmm.spi", MB_OK);
        goto NO_MEMORY_IMG;
    }
    hr = pGrab->GetCurrentBuffer(&BufferSize, (long*)*pHBm);
    
    //^肷Ƃ͂x
    if (i==1) break; //
    ret = !BWcheck(pHBInfo, pHBm);
    if (ret) break;
    LocalFree(*pHBInfo);
    *pHBInfo = NULL;
    LocalFree(*pHBm);
    *pHBm != NULL;
}

//n
ERR_ERR:
NO_MEMORY_IMG:
    LocalFree(*pHBm);
NO_MEMORY_BMH:
//NOT_MOVIE:
OPEN_ERR:
NO_INTERFACE:
    HELPER_RELEASE(pEvent);
    HELPER_RELEASE(pSeek);
    HELPER_RELEASE(pMediaControl);
    HELPER_RELEASE(pGrab);
    HELPER_RELEASE(pF);
    HELPER_RELEASE(pigb);
CREATE_ERR:
    CoUninitialize();

    return ret;
}
#else
//GetCurrentImage(),_ DirectDraw ANZ[VgpĂƎs.
//ISampleGrabber C^[tFCXgp悢.
bool __fastcall GetMovieFrame(const char *filename, HANDLE *pHBInfo, HANDLE *pHBm)
{
    bool ret = true;
    HRESULT hr;
    IGraphBuilder *pigb = NULL;
    IBasicVideo *pibv = NULL;
    IMediaPosition *pimp = NULL;
    WCHAR wFile[MAX_PATH];
    long BufferSize = 0;
    char *dibimg = NULL;
    long MWidth  = 0;
    long MHeight = 0;
    *pHBInfo = NULL;
    *pHBm = NULL;

    double seektime[2] = {0.0, 0.0};
    ifmmvar.GetPreviewPos(seektime);

    //
    CoInitialize(NULL);
    hr = CoCreateInstance(CLSID_FilterGraph,
                          NULL,
                          CLSCTX_INPROC_SERVER,
                          IID_IGraphBuilder,
                          (void**)&pigb);
    if (!SUCCEEDED(hr)) {
        //MessageBox(NULL, "DirectShow̏ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto CREATE_ERR;
    }
    hr = pigb->QueryInterface(IID_IMediaPosition, (void**)&pimp);
    if (!SUCCEEDED(hr)) {
        //MessageBox(NULL, "DirectShow̏ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto NO_INTERFACE;
    }
    hr = pigb->QueryInterface(IID_IBasicVideo, (void**)&pibv);
    if (!SUCCEEDED(hr)) {
        //MessageBox(NULL, "DirectShow̏ɎsB", "ifmm.spi", MB_OK);
        ret = false;
        goto NO_INTERFACE;
    }

    //t@CI[v
    MultiByteToWideChar(CP_ACP, 0, filename, -1, wFile, MAX_PATH);
    hr = pigb->RenderFile(wFile, NULL);
    if (!SUCCEEDED(hr)) {
        //MessageBox(NULL, "DirectShowł͍ĐłȂH", "ifmm.spi", MB_OK);
        ret = false;
        goto OPEN_ERR;
    }
    //{ɓ悩m߂
    pibv->GetVideoSize(&MWidth, &MHeight);
    if (MWidth < 1 || MHeight < 1) {
        //H
        //MessageBox(NULL, "H", "ifmm.spi", MB_OK);
        ret = false;
        goto NOT_MOVIE;
    }

for (int i=0; i<2; i++) {
    pimp->put_CurrentPosition(seektime[i]);

    //DIB̃TCY𓾂
    pibv->GetCurrentImage(&BufferSize, NULL);
    //DIBC[W𓾂
    if (dibimg != NULL) LocalFree(dibimg);
    dibimg = (char *)LocalAlloc(LMEM_FIXED, BufferSize);
    if (dibimg == NULL) {
        ret = false;
        //MessageBox(NULL, "s", "ifmm.spi", MB_OK);
        goto NO_MEMORY_DIBIMAGE;
    }
    hr = pibv->GetCurrentImage(&BufferSize, (long *)dibimg);
    if (FAILED(hr)) {
        ret = false;
        //MessageBox(NULL, "C[W擾Ɏs", "ifmm.spi", MB_OK);
        continue;
    }
#if 0
{
  FILE *fp = fopen("D:\\test\\ifmm0.bmp", "wb");
  if(fp){
    fwrite(dibimg, BufferSize, 1, fp);
    fclose(fp);
  }
}
#endif
    //24bitɕϊ
    ret = to24bit(dibimg, BufferSize, pHBInfo, pHBm);
#if 0
{
  FILE *fp = fopen("D:\\test\\ifmm1.bmp", "wb");
  if(fp){
    fwrite((char*)LocalLock(*pHBm), LocalSize(*pHBm), 1, fp);
    fclose(fp);
  }
}
#endif
    if (!ret) {
        //MessageBox(NULL, "24bitϊs", "ifmm.spi", MB_OK);
        goto NO_MEMORY;
    }

    //^肷Ƃ͂x
    if (i==1) break; //
    ret = !BWcheck(pHBInfo, pHBm);
    if (ret) break;
    LocalFree(*pHBInfo);
    *pHBInfo = NULL;
    LocalFree(*pHBm);
    *pHBm != NULL;
}

//n
ERR_ERR:
NO_MEMORY:
    LocalFree(dibimg);
NO_MEMORY_DIBIMAGE:
NOT_MOVIE:
OPEN_ERR:
NO_INTERFACE:
    HELPER_RELEASE(pibv);
    HELPER_RELEASE(pimp);
    HELPER_RELEASE(pigb);
CREATE_ERR:
    CoUninitialize();

    return ret;
}
#endif
//---------------------------------------------------------------------------
//fBAĐ
//filename  : t@C
//inmem     : ͂ȂtrueAt@C͂false
//filetype  : t@C^Cv
//lpPrgressCallback : SusiẽR[obN֐̃|C^
//lData             : R[obN֐Ŏgpf[^
//return    : SusiẽG[R[hԂ
int __fastcall MediaPlay(const char *filename, const bool inmem, const unsigned int filetype,
               const SPI_PROGRESS lpPrgressCallback, const long lData)
{
    int ret = SPI_ALL_RIGHT;
    TPlayForm *PlayForm = NULL;
try {
    PlayForm = new TPlayForm(NULL);
    PlayForm->Icon->Handle = GetIconHandle(filetype, SHGFI_SMALLICON);
    ifmmvar.Getallvar(&PlayForm->ifmmvar);
    if (PlayForm->ifmmvar.option[IFMMOPT_StayOnTop]) {
        PlayForm->FormStyle = fsStayOnTop;
    }
    int ret = MultiByteToWideChar(CP_ACP, 0, filename, -1, PlayForm->wFile, MAX_PATH);
    if (ret == 0) {
        //MessageBox(NULL, "multibyteւ̕ϊɎsB", "ifmm.spi", MB_OK);
        return SPI_OTHER_ERROR;
    }
    if (!inmem) {
        //͂łȂȂt@CLvV\
        PlayForm->Caption = ExtractFileName(filename);
    }

    Application->ProcessMessages();
    if (!PlayForm->MediaInit()) {
        //MessageBox(NULL, "DirectShow̏ɎsB", "ifmm.spi", MB_OK);
        return SPI_OTHER_ERROR;
    }
    if (!PlayForm->MediaOpen()) {
        //MessageBox(NULL, "DirectShowł͍ĐłȂH", "ifmm.spi", MB_OK);
        return SPI_OUT_OF_ORDER;
    }

    // fBA̒
    REFTIME Duration;
    PlayForm->pmp->get_Duration(&Duration); //fBA̒
    PlayForm->TheLength = Duration*1000;     //~bɕϊ
    PlayForm->TrackBar->Enabled = true;
    // ڐ蕝ύX
    if (PlayForm->TheLength > TIME_05MIN *10) {
        PlayForm->TrackBar->Frequency = TIME_10MIN; //10min
        PlayForm->per = PER_10MIN;
        PlayForm->min10->Checked = true;
    } else if (PlayForm->TheLength > TIME_01MIN *10) {
        PlayForm->TrackBar->Frequency = TIME_05MIN; // 5min
        PlayForm->per = PER_05MIN;
        PlayForm->min5->Checked = true;
    } else if (PlayForm->TheLength > TIME_30SEC *10) {
        PlayForm->TrackBar->Frequency = TIME_01MIN; // 1min
        PlayForm->per = PER_01MIN;
        PlayForm->min1->Checked = true;
    } else if (PlayForm->TheLength > TIME_10SEC *10) {
        PlayForm->TrackBar->Frequency = TIME_30SEC; //30sec
        PlayForm->per = PER_30SEC;
        PlayForm->sec30->Checked = true;
    } else if (PlayForm->TheLength > TIME_01SEC *10) {
        PlayForm->TrackBar->Frequency = TIME_10SEC; //10sec
        PlayForm->per = PER_10SEC;
        PlayForm->sec10->Checked = true;
    } else {
        PlayForm->TrackBar->Frequency = TIME_01SEC; // 1sec
        PlayForm->per = PER_01SEC;
        PlayForm->sec1->Checked = true;
    }
    // Xe[^Xo[ɕ\
    int min = PlayForm->TheLength / (1000*60);
    int sec = PlayForm->TheLength % (1000*60);
    PlayForm->length = FormatFloat("00", min) +"F"
            +FormatFloat("00.000", sec/(long double)1000);
    PlayForm->StatusBar->Panels->Items[0]->Text = PlayForm->length;
    PlayForm->StatusBar->Panels->Items[1]->Text = PlayForm->per;
    PlayForm->StatusBar->Panels->Items[2]->Text = FormatFloat((AnsiString)"0.0", PlayForm->MRate);
    PlayForm->TrackBar->Min = 0;
    PlayForm->TrackBar->Max = PlayForm->TheLength;

    //Ȃ...
    bool soundonly = true;
    if (IS_MOVIE(filetype)) {
        //Form1->ScrollBox1->HorzScrollBar->Visible = false;
        HRESULT hr;
        IBasicVideo *pibv = NULL;
        PlayForm->MWidth  = 0;
        PlayForm->MHeight = 0;
        hr = PlayForm->pgb->QueryInterface(IID_IBasicVideo, (void**)&pibv);
        if (FAILED(hr)){
            return SPI_OTHER_ERROR;
        }
        pibv->GetVideoSize(&PlayForm->MWidth, &PlayForm->MHeight);
        HELPER_RELEASE(pibv);
        if (PlayForm->MWidth < 1 || PlayForm->MHeight < 1) {
            ; //Ȃ񂾂낤
        } else {
#define DEFAULT_WIDTH 276
            RECT rc;
            soundonly = false;
            PlayForm->BorderStyle = bsSizeable; //TCYύX\
            //ő剻L
            TBorderIcons tempBI = PlayForm->BorderIcons;
            tempBI << biMaximize;
            PlayForm->BorderIcons = tempBI;
            PlayForm->Scale->Enabled = true;// \{
            PlayForm->x1->Checked = true;// TCY1{
            PlayForm->ClientWidth = (PlayForm->MWidth < DEFAULT_WIDTH +2)? DEFAULT_WIDTH: PlayForm->MWidth +2;
            PlayForm->ClientHeight =  PlayForm->MHeight +PlayForm->Panel->Height +PlayForm->StatusBar->Height +2;
            PlayForm->TrackBar->Width = PlayForm->ClientWidth -PlayForm->TrackBar->Left;
            PlayForm->StatusBar->Panels->Items[0]->Width = PlayForm->ClientWidth
                -50 -30;
                //-StatusBar1->Panels->Items[1]->Width -StatusBar1->Panels->Items[2]->Width;
            //̃TCY{
            char key;
            switch (PlayForm->ifmmvar.option[IFMMOPT_MovieSize]) {
                case MS_X1: //P{
                    key = 'c';
                    PlayForm->FormKeyPress(NULL, key);
                    break;
                case MS_X2: //Q{
                    key = 'x';
                    PlayForm->FormKeyPress(NULL, key);
                    break;
                case MS_X4: //S{
                    key = 'z';
                    PlayForm->FormKeyPress(NULL, key);
                    break;
                case MS_CS: //JX^TCY
                    key = 'v';
                    PlayForm->FormKeyPress(NULL, key);
                    break;
                case MS_FL: //tXN[i𑜓x͕ύXȂj
                    key = 'b';
                    PlayForm->FormKeyPress(NULL, key);
                    break;
            }
        }
    }

    PlayForm->PauseSB->Enabled = true;
    PlayForm->PreSB->Enabled  = true;
    PlayForm->VolTB->Enabled  = true;
    if (soundonly) {
        if (PlayForm->ifmmvar.option[IFMMOPT_WindowPos]) {
            PlayForm->Position = poDesigned;
            PlayForm->Left = PlayForm->ifmmvar.option[IFMMOPT_WindowPosX];
            PlayForm->Top  = PlayForm->ifmmvar.option[IFMMOPT_WindowPosY];
        }
        //݂̂̏ꍇŏAANeBu
        HWND hWnd = GetForegroundWindow(); //݃ANeBuWindownh
        PlayForm->Show();
        Application->ProcessMessages();
        if (PlayForm->ifmmvar.option[IFMMOPT_NoActive]) {
            SetForegroundWindow(hWnd);
        }
        if (PlayForm->ifmmvar.option[IFMMOPT_Minimized]) {
            PlayForm->WindowState = wsMinimized;
        }
    } else {
        PlayForm->Scale->Enabled = true;
        PlayForm->OnResize = PlayForm->FormResizeMovie;
        PlayForm->Show();
    }

    Application->ProcessMessages();
    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(0, PlayForm->TheLength, lData)) {// 0%
            return SPI_ABORT;
        }

    PlayForm->pmex->SetNotifyWindow((OAHWND)PlayForm->Handle, WM_GRAPHNOTIFY, 0);
    PlayForm->lpPrgressCallback = lpPrgressCallback;
    PlayForm->lData = lData;
    //PlayForm->Show(); //
    PlayForm->Play();

    PlayForm->Visible = false;

    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(PlayForm->TheLength, PlayForm->TheLength, lData)) {// 100%
            return SPI_ABORT;
        }
}
__finally {
    if (PlayForm != NULL) {
        PlayForm->MediaClose();
        delete PlayForm;
    }
}

    return ret;
}
//---------------------------------------------------------------------------

